import { MutableRefObject } from 'react';
import { Draft } from 'immer';
declare type Merger<S = any> = (obj1: Draft<Partial<S>>, obj2: Partial<S>) => Partial<S>;
export declare type CallableStateAction<S = any> = Partial<S> | ((draft: Draft<S>, newState: S | Merger<S>) => void);
export declare type SetStateAction<S = any> = (newState: CallableStateAction<S>) => void;
export declare type UseStateReturnType<S> = [S, SetStateAction<S>, MutableRefObject<S>];
declare const useState: <S = any>(initialState: S) => UseStateReturnType<S>;
export { useState as default };
